/*
                           Copyright (C) 1995 
             John R.Callahan, Sudhakar Ramakrishnan, Sun Wei.
	         Web Integrated Software Project 
                   Management and Metrics Tool
                           (WISE)

WISE [both binary and source] (hereafter, Software) is 
copyrighted by John R.Callahan, Sudhakar Ramakrishnan , Sun Wei and 
ownership remains with the authors.

The authors grant you (hereafter, Licensee), a license to use the Software
for academic, research and internal business purposes only, without a
fee.  Licensee may distribute the binary to third parties providing 
that the copyright notice and this statement appears on all copies and
that no charge is associated with such copies. 

Licensee may make derivative works.  However, if Licensee distributes
any derivative work based on or derived from the Software, then
Licensee will (1) notify the authors regarding its distribution of 
the derivative work, and (2) clearly notify users that such derivative 
work is a modified version and not the original WISE tool distributed 
by the authors.

Any Licensee wishing to make commercial use of the Software should
contact the authors to negotiate an appropriate license for such
commercial use.  Commercial use includes (1) integration of all or
part of the source code into a product for sale or license by or on
behalf of licensee to third parties, or (2) distribution of the binary
code or source code to third parties that need it to utilize a
commercial product sold or licensed by or on behalf of Licensee.

THE AUTHORS MAKE NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS 
SOFTWARE FOR ANY PURPOSE.  IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR 
IMPLIED WARRANTY.  THE AUTHORS SHALL NOT BE LIABLE FOR ANY DAMAGES
SUFFERED BY USERS OF THIS SOFTWARE.

By using or copying this Software, Licensee agrees to abide by the
copyright law and all other applicable laws of the U.S., including but
not limited, to, export control laws, and the terms of this license.
The authors shall have the right to terminate this license immediately by
written notice upon Licensee's breach of, or non-compliance with, any
of its terms.  Licensee may be held legally responsible for any
copyright infringement that is caused, directly or indirectly, by
Licensee's failure to abide by the terms of this license.

Direct notices to:
	
	John R.Callahan 
	886 Chestnut Ridge Road
	Concurrent Engineering Research Center
	West Virginia University
	Morgantown, WV 26505
	USA

	phone:	(304) 293-7226
	email:	callahan@cerc.wvu.edu
*/
#define WISEMAIN
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "msql.h"
#include "cgi.h"
#include "wise.h"

struct sortentry_t {
  char* fieldname;
  int order;
  struct sortentry_t* next;
};
typedef struct sortentry_t sortentry;
sortentry* sorthead = NULL;

char orderby[WISEBUFMAX];

void
sortby(char* field,int direction)
{
  sortentry* p;
  if(sorthead == NULL) {
    sorthead = (sortentry*)malloc(sizeof(sortentry));
    sorthead->fieldname = field;
    sorthead->order = direction;
    sorthead->next = NULL;
  } else {
    for(p=sorthead;p->next != NULL;p=p->next);
    p->next = (sortentry*)malloc(sizeof(sortentry));
    p = p->next;
    p->fieldname = field;
    p->order = direction;
    p->next = NULL;
  }
  return;
}

int
sorted(char* field)
{
  int i=1;
  sortentry* p;

  for(p=sorthead;p != NULL;p=p->next) {
    if(strcmp(field,p->fieldname) == 0) return p->order*i;
    i++;
  }
  return 0;
}

char sortvector[WISEBUFMAX];

void
dosortvector(char* except)
{
  sortentry *p;
  strcpy(sortvector,"");
  for(p=sorthead;p != NULL;p=p->next) {
    if(except == NULL || strcmp(p->fieldname,except) != 0) {
      if(p->order < 0) strcat(sortvector,"&descend=");
      else if(p->order > 0) strcat(sortvector,"&ascend=");
      strcat(sortvector,p->fieldname);
    }
  }
}

void
sql_update(char* ru,char* buf,char* lbufn,char* lbufv,form_entry *p,char* project,char* issueno)
{
  char tbuf[WISEBUFMAX];
  char nbuf[WISEBUFMAX];
  char vbuf[WISEBUFMAX];

  strcpy(tbuf,"");
  strcpy(nbuf,"");
  strcpy(vbuf,"");
  if(strcmp(p->name,"project") != 0 && strcmp(p->name,"issueno") != 0) {
    wise_formatupdate(tbuf,project,p,issueno,ru);
    wise_formatlogupdate(nbuf,vbuf,project,p);
    if(strlen(nbuf) > 0) {
      strcat(lbufn,",");
      strcat(lbufn,nbuf);
      strcat(lbufv,",");
      strcat(lbufv,vbuf);
    }
    if(strlen(tbuf) > 0) {
      if(strlen(buf) > 0) strcat(buf,",");
      strcat(buf,tbuf);
    }
  }
}

sql_submit(char* buf,char* lbufn,char* lbufv,char* issueno,char* project,char* ru, 
  form_entry *parms)
{
  int i,j,sock;
  char tbuf[WISEBUFMAX];
  char lbuf[WISEBUFMAX];
  time_t ts1970;
  struct tm *pstm;
  char dbuf[WISEBUFMAX];
  char* db;
  char* dbhost;

  if((dbhost = wise_getprojhost(project)) == NULL) {
    printf("<H1>Could not find project %s database host!</H1>",project);
    return;
  }

  wise_setprojport(project);
  if((sock = msqlConnect(dbhost)) < 0) {
    printf("<H1>Connect error: %s</H1>",msqlErrMsg);
    return;
  }

  if((db = wise_getprojdb(project)) == NULL) {
    printf("<H1>Could not get project's database name!</H1>");
    return;
  }

  if(msqlSelectDB(sock,db) < 0) {
    printf("<H1>WISE server currently unavailable<H1>");
    printf("<H2>Please try again later</H2>");
    return;
  }
  sprintf(tbuf,"update %s set project='%s',%s where issueno = %s",project,project,buf,issueno);

  ts1970 = time(NULL);
  /* cftime(dbuf,"%Y-%m-%d %T",&ts1970); */
  pstm = localtime (&ts1970);
  strftime(dbuf,WISEBUFMAX,"%Y-%m-%d %T",pstm);
  sprintf(lbuf,"insert into %slog (clock,person,issueno,project%s) values ('%s','%s',%s,'%s'%s)",
	  project,lbufn,dbuf,ru,issueno,project,lbufv);

  if(msqlQuery(sock,tbuf) < 0) {
    printf("<BR><BR>Update key %s fail: %s<BR>",issueno,tbuf);
    printf ("mSQL Error: %s <br>\n", msqlErrMsg);
    return;
  }

  if(msqlQuery(sock,lbuf) < 0) {
    printf("<BR><BR>Log %s fail: %s<BR>",issueno,lbuf);
    printf ("mSQL Error: %s <br>\n", msqlErrMsg);
    return;
  }

  msqlClose(sock);
  printf ("<html><head>\n");
  printf("<META HTTP-EQUIV=\"REFRESH\" CONTENT=\"1; ");
  dosortvector(NULL);
  printf("URL=http://%s:%s/%s?project=%s&issue=%s",
          WISEHOST,WISEPORT,WISE_TDL,project,issueno);
#ifdef NEWREPORT 
  wise_print_query_opts (project, parms);
#endif /* NEWREPORT */
  printf("%s\"><BR>\n",sortvector);
  printf ("</head><body>\n");
  printf("<H1>Issue number %s was updated<BR>\n",issueno);
  printf("<blink>Please wait</blink></H1>\n");
  printf ("</body></html>\n");
}

int
main()
{
  char* ru;
  cgi_info ci;
  char buf[WISEBUFMAX];
  char lbufn[WISEBUFMAX];
  char lbufv[WISEBUFMAX];
  int status = 0;
  int more = 0;
  int deleteit = 0;
  char* issueno = NULL;
  char* project = NULL;
  form_entry *parms,*p;

  /* initialize buffer */
  strcpy(buf,"");
  strcpy(lbufn,"");
  strcpy(lbufv,"");

  /* display MIME header */
  printf("Content-type: text/html\n\n");

  /* get the name of the remote user */
  if((ru = getenv("REMOTE_USER")) == NULL) {
    int i;
    extern char ** environ;
    printf("<H1>Error: cannot get remote user name</H1>");
    for (i=0; environ[i]; i++) {
      printf (" env is %d %s <br>\n", i, environ[i]);
    }
    return 0;
  }

  /* load command line parameters */
  status = get_cgi_info( &ci );  
  if (!status) {
    printf("<h1>Error: Processing CGI info</h1>");
    return 0;
  }

  /* build and submit the update */
  parms = get_form_entries( &ci);

  for(p=parms;p;p=p->next) {
    if(strlen(p->name) > WISEBUFMAX || strlen(p->val) > WISEBUFMAX) {
      printf("<h1>Error: Submission strings too long.  Try again...</h1>");
      return 0;
    }
    wise_replace(p->val,'\'','`',strlen(p->val));
    if(strcmp(p->name,"ascend") == 0) {
      sortby(p->val,1);
    } else if(strcmp(p->name,"descend") == 0) {
      sortby(p->val,-1);
    } else if(strcmp(p->name,"issueno") == 0) {
      issueno = p->val;
    } else if(strcmp(p->name,"project") == 0) {
      project = p->val;
    } else if(strcmp(p->name,"delete") == 0) {
      deleteit = 1;
    }
  }
  if(deleteit && project != NULL && issueno != NULL) {
    dosortvector(NULL);
    if(wise_deleteissue(project,issueno)) {
      printf("<META HTTP-EQUIV=REFRESH CONTENT=\"1; ");
      printf("URL=http://%s:%s/%s?project=%s%s",
	     WISEHOST,WISEPORT,WISE_TDL,project,sortvector);
#ifdef NEWREPORT 
      wise_print_query_opts (project, parms);
#endif /* NEWREPORT */
      printf("><BR>");
      printf("<H1>Issue %s has been deleted<BR>",issueno);
      printf("<blink>Please wait</blink></H1>");
    } else {
      printf("<H1>Issue NOT deleted</H1><BR>");
      printf("<H2>Select <A HREF=\"http://%s:%s/%s?project=%s%s",
	     WISEHOST,WISEPORT,WISE_TDL,project,sortvector);
#ifdef NEWREPORT 
      wise_print_query_opts (project, parms);
#endif /* NEWREPORT */
      printf("\">here</A> to return to project listing</H2>");
    }
    exit(0);
  } else if(deleteit) {
    printf("<H1>Issue NOT deleted</H1><BR>");
    exit(0);
  }
  if(project == NULL) {
    printf("<H1>Cannot find project name</H1>");
    return 0;
  }
  if(issueno == NULL) {
    printf("<H1>Cannot find issue number</H1>");
    return 0;
  }
  p = parms;
  for(;parms;parms=parms->next) {
    sql_update(ru,buf,lbufn,lbufv,parms,project,issueno);
    if(WISEDEBUG) printf("name,val = %s,%s<BR>",parms->name,parms->val);
    if(WISEDEBUG) printf("update buffer = %s<BR>",buf);
  }
  parms = p;
  sql_submit(buf,lbufn,lbufv,issueno,project,ru, parms);
  free_form_entries(parms);

  return 0;
}
